@echo off

REM
REM script to run password encrypt logic
REM

REM Collect the command line args

set JS_CMD_NAME=%0

set CMD_LINE_ARGS=
:setArgs
if ""%1""=="""" goto doneSetArgs
set CMD_LINE_ARGS=%CMD_LINE_ARGS% %1
shift
goto setArgs
:doneSetArgs

REM
REM Uncomment to set password in this script file instead of on the command line 
REM Uncomment the line below to use the password you specify on the line below
REM set CMD_LINE_ARGS= --pass myPassword

REM Set the configuration folder to use
REM if Pro config exists, then set to Pro config
REM otherwise, assume ce config

if exist "conf_source\iePro" goto setConfPro
set CONFIG_DIR=conf_source\ieCe
goto doneSetConf
:setConfPro
set CONFIG_DIR=conf_source\iePro
:doneSetConf

REM Add all jars the export classpath variable
set EXP_CLASSPATH=%CONFIG_DIR%\lib\*

REM Set the java command
REM
REM If "..\java\bin\java.exe" exists then use it
REM

if exist "..\java\bin\java.exe" goto setLocalJava

goto setStandardJava
:setLocalJava

set JAVA_HOME="..\java"
set PATH=..\java\bin;%PATH%

goto doneJava
:setStandardJava

if "%JAVA_HOME%"=="" goto warnJava

goto doneJava
:warnJava

echo "WARNING: Did not find a JAVA_HOME environment variable setting. Script will continue."

:doneJava

REM Set java memory options

set JAVA_OPTS=%JAVA_OPTS% -Xms32m -XX:PermSize=32m

REM Add config dir to EXP_CLASSPATH

set EXP_CLASSPATH=%CONFIG_DIR%;%EXP_CLASSPATH%;.

java -classpath "%EXP_CLASSPATH%" %JAVA_OPTS% com.jaspersoft.jasperserver.export.util.EncryptionUtils %JS_CMD_NAME% %CMD_LINE_ARGS%

